//+------------------------------------------------------------------+
//|                                                  MarketHours.mq4 |
//|                                        Copyright  2009  DareXau |
//|                                               darex.au@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009  DareXau"
#property link      "mailto:darex.au@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 ForestGreen
#property indicator_width1 3
#property indicator_color2 Goldenrod
#property indicator_width2 3
#property indicator_color3 MediumBlue
#property indicator_width3 3
#property indicator_color4 Crimson
#property indicator_width4 3
#property indicator_maximum 9
#property indicator_minimum 0
//+------------------------------------------------------------------+
extern int SydneyOpen = 1;
extern int SydneyClose = 9;
extern int TokyoOpen = 3;
extern int TokyoClose = 13;
extern int LondonOpen = 10;
extern int LondonClose = 19;
extern int NewYorkOpen = 15;
extern int NewYorkClose	= 1;
//+------------------------------------------------------------------+
double dLondonBuffer[];
double dNewYorkBuffer[];
double dSydneyBuffer[];
double dTokyoBuffer[];
//+------------------------------------------------------------------+
int init() {

	IndicatorShortName("");
	
	SetIndexBuffer(0,dSydneyBuffer);
	SetIndexLabel(0,"Sydney");
	SetIndexBuffer(1,dTokyoBuffer);
	SetIndexLabel(1,"Tokyo");
	SetIndexBuffer(2,dLondonBuffer);
	SetIndexLabel(2,"London");
	SetIndexBuffer(3,dNewYorkBuffer);
	SetIndexLabel(3,"New York");
	
	return(0);
}
//+------------------------------------------------------------------+
int start() {

	// Determine number of bars to iterate over
	int iBarsToCalc = Bars - IndicatorCounted();
	if (iBarsToCalc < Bars) iBarsToCalc++;
	
	// Iterate over bars
	for (int i=iBarsToCalc-1;i>=0;i--) {

		// Set Sydney Line
		if (isMarketOpen(SydneyOpen, SydneyClose, Time[i]))
			dSydneyBuffer[i] = 2;
		else
			dSydneyBuffer[i] = EMPTY_VALUE;
		// Set Tokyo Line
		if (isMarketOpen(TokyoOpen, TokyoClose, Time[i]))
			dTokyoBuffer[i] = 4;
		else
			dTokyoBuffer[i] = EMPTY_VALUE;
		// Set London Line
		if (isMarketOpen(LondonOpen, LondonClose, Time[i]))
			dLondonBuffer[i] = 6;
		else
			dLondonBuffer[i] = EMPTY_VALUE;
		// Set NewYork Line
		if (isMarketOpen(NewYorkOpen, NewYorkClose, Time[i]))
			dNewYorkBuffer[i] = 8;
		else
			dNewYorkBuffer[i] = EMPTY_VALUE;

	}

}
//+------------------------------------------------------------------+
bool isMarketOpen(int iOpenHour, int iCloseHour, datetime timestamp) {

	int iBarHour = TimeHour(timestamp);
	
	if (iOpenHour < iCloseHour && (iBarHour >= iOpenHour && iBarHour < iCloseHour))
		return(true);
	if (iOpenHour > iCloseHour && (iBarHour >= iOpenHour || iBarHour < iCloseHour))
		return(true);
		
	return(false);
}
//+------------------------------------------------------------------+