//+------------------------------------------------------------------+
//|                                            Market Open-Close.mq4 |
//|                                        Copyright  2009  DareXau |
//|                                               darex.au@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009  DareXau"
#property link      "mailto:darex.au@gmail.com"

#property indicator_chart_window
	/* Markets open and close hours addjusted to the broker time and day-light saving time */
extern string   Wellington_Open        = "01:00";	/* Wellington open  10:00 local time */
extern string   Wellington_Close       = "06:45";	/* Wellington close 16:45 local time */
extern string   Sydney_Open            = "03:00";	/* Sydney open  10:00 local time */
extern string   Sydney_Close           = "09:00";	/* Sydney close 16:00 local time */
extern string   Tokyo_Open             = "03:00";	/* Tokyo open  09:00 local time */
extern string   Tokyo_Close            = "12:00";	/* Tokyo close 18:00 local time */
extern string   HongKong_Open          = "05:00";	/* HongKong open  10:00 local time */
extern string   HongKong_Close         = "11:00";	/* HongKong close 16:00 local time */
extern string   Frankfurt_Open         = "10:00";	/* Frankfurt open  09:00 local time */
extern string   Frankfurt_Close        = "18:30";	/* Frankfurt close 17:30 local time */
extern string   London_Open            = "10:00";	/* London open  08:00 local time */
extern string   London_Close           = "19:00";	/* London close 17:00 local time */
extern string   NewYork_Open           = "15:00";	/* New York open  08:00 local time */
extern string   NewYork_Close          = "00:00";	/* New York close 17:00 local time */

extern color    LineColor      = Olive;
extern int      LabelPipOffset = 900;
extern int      LabelFontSize  = 9;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	/* Delete objects */
	ObjectDelete("WelOpen");
	ObjectDelete("WelOpen_Label");
	ObjectDelete("WelClose");
	ObjectDelete("WelClose_Label");
	ObjectDelete("SydOpen");
	ObjectDelete("SydOpen_Label");
	ObjectDelete("SydClose");
	ObjectDelete("SydClose_Label");
	ObjectDelete("TokOpen");
	ObjectDelete("TokOpen_Label");
	ObjectDelete("TokClose");
	ObjectDelete("TokClose_Label");
	ObjectDelete("HKOpen");	
	ObjectDelete("HKOpen_Label");
	ObjectDelete("HKClose");	
	ObjectDelete("HKClose_Label");	
	ObjectDelete("FraOpen");
	ObjectDelete("FraOpen_Label");
	ObjectDelete("FraClose");
	ObjectDelete("FraClose_Label");
	ObjectDelete("LonOpen");
	ObjectDelete("LonOpen_Label");
	ObjectDelete("LonClose");
	ObjectDelete("LonClose_Label");
	ObjectDelete("NYOpen");
	ObjectDelete("NYOpen_Label");
	ObjectDelete("NYClose");
	ObjectDelete("NYClose_Label");
	
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   /* If period > 1hour, don't draw the lines */
   if (Period() > PERIOD_H1) return(0);
   
   /* Draw the market open and close lines */
   DrawLine("WelOpen","Wellington Open",Wellington_Open);
   DrawLine("WelClose","Wellington Close",Wellington_Close);
   DrawLine("SydOpen","Sydney Open",Sydney_Open);
   DrawLine("SydClose","Sydney Close",Sydney_Close);
   DrawLine("TokOpen","Tokyo Open",Tokyo_Open);
   DrawLine("TokClose","Tokyo Close",Tokyo_Close);
   DrawLine("HKOpen","HongKong Open",HongKong_Open);
   DrawLine("HKClose","HongKong Close",HongKong_Close);
   DrawLine("FraOpen","Frankfurt Open",Frankfurt_Open);
   DrawLine("FraClose","Frankfurt Close",Frankfurt_Close);
   DrawLine("LonOpen","London Open",London_Open);
   DrawLine("LonClose","London Close",London_Close);
   DrawLine("NYOpen","New York Open",NewYork_Open);
   DrawLine("NYClose","New York Close",NewYork_Close);

   return(0);
}
//+------------------------------------------------------------------+
void DrawLine(string ObjName, string ObjText, string OpenTime)
{
   /* Convert the open time string to datetime */
   datetime t = StrToTime(OpenTime);
   
   /* Create the vertical lines */
   ObjectCreate(ObjName,OBJ_VLINE,0,t,0);
   ObjectSet(ObjName,OBJPROP_BACK,true); 
   ObjectSet(ObjName,OBJPROP_COLOR,LineColor);
   ObjectSet(ObjName,OBJPROP_STYLE,STYLE_DOT);
   
   /* Determine the vertical position of the label object */
   double p = High[iHighest(NULL,0,MODE_HIGH,WindowBarsPerChart(),1)];
   p = p-(LabelPipOffset*Point);
   
   /* Draw the label object */
   ObjectCreate(ObjName+"_Label",OBJ_TEXT,0,t,p);
   ObjectSetText(ObjName+"_Label",ObjText,LabelFontSize);
   ObjectSet(ObjName+"_Label",OBJPROP_ANGLE,90);
   ObjectSet(ObjName+"_Label",OBJPROP_COLOR,LineColor);

   return(0);
}
//+------------------------------------------------------------------+